#include <minigui.ch>


Function Accyr()

   if isWindowDefined(frmAccyr)
      return nil
   endif

   prepare_data()

   define window frmAccyr ;
      at 0, 0 width 600 height 500 ;
      title "Acounting year" ;
      modal nosysmenu ;
      on init get_data() ;
      on size form_resize()


*       DEFINE STATUSBAR
*       STATUSITEM "CTRL+A: Add new, CTRL+E: Edit, CTRL+D: Delete, Dbl-Click: Select"
*       END STATUSBAR


      @ 0, 0 grid grdAccyr ;
         width 330 height 450 ;
         HEADERS { 'A/c Year ID', 'From', 'To' } ;
         WIDTHS { 100, 100, 100 } ;
         justify { 0, 0} ;
         on dblclick AccyrSelect()
      
      @ 100, 400 button cmdAdd caption "&Add" action AccyrChange(.t.)
      @ 130, 400 button cmdModify caption "&Modify" action AccyrChange(.f.)
      @ 160, 400 button cmdDelete caption "&Delete" action AccyrDelete()
      
      @ 220, 400 button cmdSelect caption "&Select" action AccyrSelect()
      @ 250, 400 button cmdCancel caption "&Cancel" action Quit_Prog()
         
   end window
*    on key CONTROL+A of frmAccyr			action AccyrChange(.t.)
*    on key CONTROL+E of frmAccyr			action AccyrChange(.f.)
*    on key CONTROL+D of frmAccyr        action AccyrDelete()
   frmAccyr.center
   frmAccyr.activate

return nil




function get_data()
   local aRec := {}, i
   aRec := sql(dbo, "select Accyrid, Accfrom, Accto from Accyr order by Accfrom")
   //aRec := sql(dbo, "select * from accyr")
   frmAccyr.grdAccyr.DeleteAllItems()
   for i := 1 to len(aRec)
      frmAccyr.grdAccyr.additem({aRec[i, 1], dtoc(aRec[i, 2]), dtoc(aRec[i, 3])})
   next
   form_resize()
return nil



function AccyrDelete()
   local lineno, mAccyrid, mAccfrom, mAccto
   lineno := frmAccyr.grdAccyr.value
   if lineno < 1
      return nil
   endif
   mAccyrid := frmAccyr.grdAccyr.cell(lineno, 1)
   mAccfrom := ctod(frmAccyr.grdAccyr.cell(lineno, 2))
   mAccto   := ctod(frmAccyr.grdAccyr.cell(lineno, 3))
   if  lineno > 0 .and. msgyesno("Do you really delete "+dtoc(mAccfrom)+" to "+dtoc(mAccTo)+" ?")
      if miscsql(dbo, "delete from Accyr where Accyrid = '"+alltrim(mAccyrid)+"'")
         frmAccyr.grdAccyr.deleteitem( lineno )
         if lineno > 1
            frmAccyr.grdAccyr.value := lineno -1
         else
            if frmAccyr.grdAccyr.itemcount > 0
               frmAccyr.grdAccyr.value := 1
            endif
         endif
      endif
   endif
return nil




Function  AccyrChange( lAddmode )
   local linino, mAccyrid, mAccfrom, mAccto
   lineno := iif(lAddmode, frmAccyr.grdAccyr.itemcount+1, frmAccyr.grdAccyr.value)
   if lineno < 1
      return nil
   endif

   mAccyrid := iif(lAddmode, "", frmAccyr.grdAccyr.cell(lineno, 1))
   mAccfrom := iif(lAddmode, ctod(""), ctod(frmAccyr.grdAccyr.cell(lineno, 2)))
   mAccto   := iif(lAddmode, ctod(""), ctod(frmAccyr.grdAccyr.cell(lineno, 3)))

   DEFINE WINDOW frmAccyrChange ;
      AT 0,0 ;
      WIDTH 485 HEIGHT 240 ;
      TITLE iif( lAddmode , "Add new A/c Year" , "Modify A/c year record" )  ;
      MODAL ;
      NOSYSMENU

      @ 20, 30 LABEL lblAccyrid ;
         VALUE "Code:"

      @ 20, 130 textbox txtAccyrid ;
         value mAccyrid maxlength 10

      @ 50, 30 LABEL lblAccfrom ;
         VALUE "From:"

      @ 50, 130 textbox txtAccfrom ;
         value mAccfrom DATE ;
         on change CreateAccyrId()

      @ 80, 30 LABEL lblAccto ;
         VALUE "To:"

      @ 80, 130 textbox txtAccto ;
         value mAccto DATE ;
         on change CreateAccyrId()

      @ 165,100 BUTTON cmdConfirm ;
         CAPTION '&Save' ;
         ACTION SaveRecord( lineno, lAddmode )

      @ 165,300 BUTTON cmdCancel ;
         CAPTION '&Cancel' ;
         ACTION frmAccyrChange.Release

   END WINDOW

   frmAccyrChange.txtAccyrid.readonly := .t.
   frmAccyrChange.center
   frmAccyrChange.activate
Return Nil



function SaveRecord(lineno, lAddmode)
   local mAccyrid, mAccfrom, mAccto
   mAccyrid := padr(alltrim(frmAccyrChange.txtAccyrid.value), 10)
   mAccfrom := frmAccyrChange.txtAccfrom.value
   mAccto   := frmAccyrChange.txtAccto.value
   if empty(mAccyrid)
      msgbox("A/c Year ID cannot be blank!")
      return nil
   endif
   if empty(mAccfrom)
      msgbox("A/c year from cannot be blank")
      return nil
   endif
   if empty(mAccto)
      msgbox("A/c year to cannot be blank")
      return nil
   endif
   if mAccfrom > mAccto
   	msgbox("Invalid date range!")
   	return nil
   endif
   
   if lAddmode
      if miscsql(dbo, "insert into Accyr (Accyrid, Accfrom, Accto) values ('"+mAccyrid+"', "+c2sql(mAccfrom)+", "+c2sql(mAccto)+")")
         frmAccyrChange.release()
         frmAccyr.grdAccyr.additem({mAccyrid, dtoc(mAccfrom), dtoc(mAccto)})
         frmAccyr.grdAccyr.value := frmAccyr.grdAccyr.itemcount
         return nil
      endif
   else
   	
      if miscsql(dbo, "update Accyr set Accfrom="+c2sql(mAccfrom)+", Accto="+c2sql(mAccto)+" where Accyrid='"+mAccyrid+"'")
//      	msgbox("update Accyr set Accfrom = "+c2sql(mAccfrom)+", Accto = "+c2sql(mAccto)+" where Accyrid = '"+mAccyrid+"'")
         frmAccyrChange.release()
         frmAccyr.grdAccyr.item(lineno) := {mAccyrid, dtoc(mAccfrom), dtoc(mAccto)}
         return nil
      endif
   endif
return nil	



function form_resize()
	return nil
   frmAccyr.grdAccyr.col := 0
   frmAccyr.grdAccyr.row := 0
   frmAccyr.grdAccyr.width := frmAccyr.width-10
   frmAccyr.grdAccyr.height := frmAccyr.height-50
return nil



Function Prepare_data()
   local i
   if !DbExist(dbo, cDatabase)
      Dbo:CreateDatabase( cDatabase )
      If Dbo:NetErr()
         MsGInfo("Error creating database: " + Dbo:Error() )
         Release Window ALL
         Quit
      Endif
   endif
   Dbo:selectdb(cDatabase)
   if !TableExist(dbo, "Accyr")
      if !MiscSql(dbo, "CREATE TABLE Accyr"+ ;
         " ( Accyrid CHAR(10) NOT NULL,  Accfrom DATE NOT NULL, Accto DATE NOT NULL, PRIMARY KEY (Accyrid)) ")
         release window all
         quit
      endif
   endif
Return Nil


static function AccyrSelect()
   local lineno
   lineno := frmAccyr.grdAccyr.value
   if lineno < 1
      return nil
   endif
   _Accyrid := frmAccyr.grdAccyr.cell(lineno, 1)
   _Accfrom := ctod(frmAccyr.grdAccyr.cell(lineno, 2))
   _Accto   := ctod(frmAccyr.grdAccyr.cell(lineno, 3))
   setproperty('frmMain', 'title', 'InfoSQL: '+_Accyrid)
   
   _Database := "Info"+str(year(_accfrom), 4)+str(year(_accto), 4)
	if !DbExist(dbo, _Database)
      Dbo:CreateDatabase( _Database )
      If Dbo:NetErr()
         MsGInfo("Error creating database: " + Dbo:Error() )
         Release Window ALL
         Quit
      Endif
   endif
   Dbo:selectdb(_Database)
   thiswindow.release()

   
return nil



Static function CreateAccyrid()
	if !IsControlDefined(txtAccfrom, frmAccyrChange) .or. ;
		!IsControlDefined(txtAccto, frmAccyrChange)
		return nil
	endif
   frmAccyrChange.txtAccyrid.value := ;
   	padr(ltrim(str(year(frmAccyrChange.txtAccfrom.value)))+"-"+ltrim(str(year(frmAccyrChange.txtAccto.value))), 10)
   return nil
