#Include "MiniGui.ch"


Procedure Main()
   Private Dbo := Nil
   Private cHostName:= "localhost"
   Private cUser:= ""
   Private cPassWord:= ""
   Private cDataBase:= "INFO"
   Private lLogin:= .F.
   private _accyrid, _accfrom, _accto
   
   _accyrid := space(10)
   _accfrom := ctod("")
   _accto := ctod("")
   _database := ""
   
   Set_prog()

   DEFINE WINDOW frmMain ;
      AT 5,5 ;
      WIDTH 640 ;
      HEIGHT 480;
      TITLE "InfoSQL" ;
      MAIN ;
      NOSIZE ;
      NOMINIMIZE ;
      BACKCOLOR {0, 128, 192}; 
      ON INIT {|| MySQL_Login(), Accyr()} ;
      ON RELEASE MySQL_Logout()
      
      
      @ 23, 27 LABEL lbl_1 VALUE "InfoSQL: Never abandon your dream ..." AUTOSIZE ;
         FONT "Verdana" SIZE 24 BOLD ITALIC ;
         FONTCOLOR BLACK TRANSPARENT
      @ 20, 24 LABEL lbl_2 VALUE "InfoSQL: Never abandon your dream ..." AUTOSIZE ;
         FONT "Verdana" SIZE 24 BOLD ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT

      @ 100, 24 LABEL lbl_5 ;
         VALUE "Developed by: Sudip Bhatttacharyya" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 120, 24 LABEL lbl_6 ;
         VALUE "Email:" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 120, 65 hyperlink email ;
         value "sudipb001@gmail.com" ;
         width 200 ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT HANDCURSOR ;
         address "sudipb001@gmail.com"
         
      @ 150, 24 LABEL lbl_7 ;
         VALUE "Created with HMG, by Roberto Lopez" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      @ 170, 24 LABEL lbl_8 ;
         VALUE "Created with help from S. Rathinagiri" AUTOSIZE ;
         FONT "Tahoma" SIZE 10 ;//ITALIC ;
         FONTCOLOR { 151, 223, 255 } TRANSPARENT
      

      DEFINE STATUSBAR
      STATUSITEM " "
      END STATUSBAR

      DEFINE MAIN MENU
         POPUP "&File"
            Item "E&xit"               action quit_prog()
         end popup
*          popup "&Entry"
*             item "&Customer"           action cust()
*          end popup
      END MENU

   END WINDOW

   MAXIMIZE WINDOW frmMain
   ACTIVATE WINDOW frmMain

Return Nil


Function Set_prog()
   set talk off
   set dele on
   set date brit
   set cent on
   set epoch to 1950
   SET BROWSESYNC ON
   set font to "Arial", 09
   set navigation extended
   //REQUEST DBFCDX , DBFFPT
   //RDDSETDEFAULT( "DBFCDX" )
   return nil

   
   
function Quit_Prog()
	release window all
	return nil      


static function MySql_login()
   DEFINE WINDOW frmLogon ;
      AT 0,0 ;
      WIDTH 280 HEIGHT 180 ;
      TITLE 'Login' ;
      MODAL ;
      NOSYSMENU

      @ 20,30 LABEL lblHostName ;
         VALUE "HostName/IP" ;
         WIDTH 150 ;
         HEIGHT 35

		@ 20,120 TEXTBOX txtHostName ;
         HEIGHT 25 ;
         VALUE cHostName ;
         WIDTH 120 

      @ 50,30 LABEL lblUser ;
         VALUE "User" ;
         WIDTH 120 ;
         HEIGHT 35

      @ 50,120 TEXTBOX  txtUser ;
         HEIGHT 25 ;
         VALUE cUser ;
         WIDTH 120 

      @ 80,30 LABEL lblPassword ;
         VALUE "Password" ;
         WIDTH 120 ;
         HEIGHT 35

      @ 80,120 TEXTBOX txtPassword ;
         VALUE cPassWord ;
         PASSWORD 

      @ 120,30 BUTTON cmdLogin ;
         CAPTION '&Login' ;
         ACTION SQL_Connect()

      @ 120,143 BUTTON cmdLogoff ;
         CAPTION '&Cancel' ;
         ACTION frmMain.Release

   END WINDOW

   CENTER WINDOW frmLogon
   ACTIVATE WINDOW frmLogon

Return Nil





Function SQL_Connect()
   cHostName:= AllTrim(  frmLogon.txtHostName.Value )
   cUser:= AllTrim( frmLogon.txtUser.Value )
   cPassWord:= AllTrim( frmLogon.txtpassword.Value )

   Dbo := TMySQLServer():New(cHostName, cUser, cPassWord )
   If Dbo:NetErr()
      MsGInfo("Error connecting to SQL server: " + Dbo:Error() )
      Release Window ALL
      Quit
   Endif               	
   lLogin := .T.
   frmLogon.Release
   frmMain.StatusBar.Item(1) := "MySql Server Connected!!!"
Return Nil



